//Description of Link State Database. Header file for LSDatabase.cpp

#include<stdio.h>

#ifndef deftestrlsa
 #include "Router_LSA.h"
#endif

#define	deftestlsadb

class LSDatabase
{
  //Constructor, Get, Set etc.
 public:
  LSDatabase();
  ~LSDatabase();
  int getnRLSA();
  int existRouterLSA(IP lsID);
  Router_LSA getRouterLSA(int index);
  Router_LSA getRouterLSA(IP lsID);

  //OSPF related methods
  int addRLSALink(IP lsID, IP linkID, IP linkData, char type, short cost);
  int addRouterLSA(Router_LSA rlsa);
  int updateRouterLSA(Router_LSA rlsa);

  //Operational methods
  void display(FILE* outFile);
  
  //OSPF related data members  
 private:
  int rLSAs;
  Router_LSA *router_LSAs;
};
