// header for Link_State_Update_Packet.h

#ifndef deftestlsabase
 #include "LSA_Base.h"
#endif

#ifndef deftestospfpb
 #include "OSPF_Packet_Base.h"
#endif

#ifndef deftestrlsa
 #include "Router_LSA.h"
#endif

#define	deftestlsup

class Link_State_Update_Packet : public OSPF_Packet_Base  
{
 public:
  Link_State_Update_Packet(IP router);
  Link_State_Update_Packet();
  ~Link_State_Update_Packet();
  Link_State_Update_Packet & operator=(Link_State_Update_Packet &right);
  int getnRLSA();
  Router_LSA getRLSA(int index);
  int addRLSA(Router_LSA rlsa);
  
 private: 
  int num_rLSA;
  Router_LSA *rLSAs;
};
