// header for Router_LSA.cpp

#include <stdio.h>

#ifndef deftestlsabase
 #include "LSA_Base.h"
#endif

#ifndef deftestlinkdata
 #include "Link_Data.h"
#endif

#define	deftestrlsa

class Router_LSA : public LSA_Base  
{
  // Constructors, Get, Set etc.
 public:  
  Router_LSA(IP lsID, IP advRouter);
  Router_LSA();
  ~Router_LSA();
  Link_Data getLink(int index);
  unsigned short getNumLinks();
  
  //OSPF related methods
  int addLink(IP id, IP data, char type, unsigned short metric);
  
  //operational methods
  void display(FILE* outFile);
  Router_LSA & operator=(Router_LSA &right);
  int operator==(Router_LSA &right);
  
  // Data Members for Class Attributes
 private:
  char optionsVEB;//
  char optionsFixed;//always set to 0
  unsigned short num_Links;
  Link_Data *links;
};

